import Editor from './editor'
import MessageBox from './messageBox'
import Modal from './modal'
import Notify from './notify'
import Upload from './upload'
import Loader from './loader'
import Panel from './panel'

export * from './editor'
export * from './messageBox'
export * from './modal'
export * from './notify'
export * from './upload'
export * from './loader'
export * from './panel'

export default {
  atEditor: Editor,
  atMessageBox: MessageBox,
  atModal: Modal,
  atNotify: Notify,
  atUpload: Upload,
  atLoader: Loader,
  AtPanel: Panel,
  install(Vue, opts = {}) {
    if (opts.editor !== false) {
      Vue.use(Editor, opts.editor)
    }
    if (opts.messageBox !== false) {
      Vue.use(MessageBox, opts.messageBox)
    }
    if (opts.modal !== false) {
      Vue.use(Modal, opts.modal)
    }
    if (opts.notify !== false) {
      Vue.use(Notify, opts.notify)
    }
    if (opts.upload !== false) {
      Vue.use(Upload, opts.upload)
    }
    if (opts.loader !== false) {
      Vue.use(Loader, opts.loader)
    }
    if (opts.panel !== false) {
      Vue.use(Panel, opts.panel)
    }
  }
}
