import {
  restructureDefaultPropsOfVueCtorFromOptions
} from '@packages/utils'
import AtUploadCtor from './components/main'
import AtImageUploadCtor from './components/ImageUpload'

let AtUpload = AtUploadCtor
let AtImageUpload = AtImageUploadCtor

export {
  AtUpload,
  AtImageUpload
}

export default {
  install(Vue, opts = {}) {
    let {
      upload,
      imageUpload
    } = Object.assign({}, opts)

    if (upload !== false) {
      Vue.component('at-upload', restructureDefaultPropsOfVueCtorFromOptions(AtUploadCtor, upload))

      if (imageUpload !== false) {
        Vue.component('at-image-upload', restructureDefaultPropsOfVueCtorFromOptions(AtImageUploadCtor, imageUpload))
      }
    }
  }
}
