import options, {
  merge as mergeOptions
} from './options'
import VueAsset from './components'
import plugins from './plugins'
import filters from './filters'
import third from './third'
import * as utils from './utils'
import './scss/base.scss'

// if (typeof window !== 'undefined' && window.Vue) {
//   VueAsset.install(window.Vue)
// }

export * from './components'
export {
  utils,
  options
}

export default {
  install(Vue, opts = {}) {
    opts = mergeOptions(opts)

    if (opts.plugins !== false) {
      Vue.use(plugins, opts.plugins)
    }

    if (opts.filters !== false) {
      Vue.use(filters, opts.filters)
    }

    if (opts.components !== false) {
      Vue.use(VueAsset, opts.components)
    }

    if (opts.third !== false) {
      Vue.use(third, opts.third)
    }
  }
}
