import Vue from 'vue'
import App from './App.vue'
import packages from '@packages'
import '../packages/scss/base.scss'
import router from './router'
import ElementUI from 'element-ui'
import axios from 'axios'
import {
  fmt,
  eachOwn
} from '@packages/utils'

Vue.use(ElementUI)

eachOwn(fmt, (filter, name) => {
  Vue.filter(name, filter)
})

Vue.use(packages, {
  // 详细配置查看各组件/插件
  components: {
    upload: {
      imageUpload: {
        action: 'http://baidu.com'
      }
    }
  },
  plugins: {
    axios: {
      defaults: {
        baseURL: 'http://120.55.12.229:9001/eam/',
        responseType: 'text'
      }
    }
  },
  third: {
    qiniu: {
      httpRequest: {
        qiniuTokenUrl(type) {
          return `http://eam-api.asset-dev.h5h5h5.cn/eam/v1.0/common/${type}/qiniu_token`
        }
      }
    }
  },
  utils: {
    fmt: {
      date: {
        format: 'yyyy-MM-dd hh:mm'
      }
    }
  }
})
console.log(axios.defaults)

new Vue({
  el: '#app',
  router,
  render: h => h(App)
})
